//+-------------------------------------------------------------------------------+
//|                                               Momentum Scalper TEST  
//|                                                              
//|                                                                                         
//+------------------------------------------------------------------------------+

// Description
// In this TEST version the screen is painted in pale green when the higher Timeframe 
// is positive, pink when the higher Timeframe is negative
// 
// 
// Function Symbol(), that is an MT4 function, is not called to make the indi
// usable with Gold and indices 

#property copyright ""

#property indicator_separate_window 

#property indicator_level1    100   // Attenzione livelli e Momentum sono diversi
#property indicator_level2    -100  // Questo  da considerarsi livello di OverSold OverBought
//#property indicator_level3    0
#property indicator_levelcolor   Black
#property indicator_levelstyle   STYLE_DOT

#property indicator_buffers 5 
#property indicator_color1    DimGray
#property indicator_color2    Blue
#property indicator_color3    Orange
#property indicator_color4    Red
#property indicator_color5    White
#property indicator_style1    STYLE_SOLID
#property indicator_style2    STYLE_SOLID
#property indicator_style3    STYLE_SOLID
#property indicator_style4    STYLE_SOLID
#property indicator_style5    STYLE_SOLID
#property indicator_width1    5
#property indicator_width2    5
#property indicator_width3    5
#property indicator_width4    5
#property indicator_width5    5

//---- input parameters
extern string TimeFrame = "current time frame";
extern int       Momentum_Period=5;
extern int       num_bars=1000;

extern int       momentum=100;

extern string    Over_S_B__equals_Indi_Levels="**Comment**";
extern int       OverSold_OverBought=100;

extern string    Color_of_Background="**Comment**";  // Choose background color for Indicator Window
extern string    of_higher_TF="**Comment**";
extern bool      Show_Different_Background=TRUE;
extern color     Positive_Background_Color=PaleGreen;
extern color     Negative_Background_Color=Pink;

extern string    Use_this_to_show_Blue_Histos="**Comment**";
extern string    when_Momentum_is_not_reached="**Comment**";
extern bool      Always_Show_Price_Divergence=False;

extern string    Different_Background_on_Chart="**Comment**";
extern bool      Main_Window_Background=True;  // Use this to paint Main Window

// parameters 
bool initDo=true;
int bar=0; int prevbars=0; int startpar=0;
int cs=0; int prevcs=0; int frame=0;
string commodt="nothing";

string Indi_Name;

bool expired=false;
double now, prev, now_high, prev_high, now_low, prev_low;
double Max_CCI=0, Max_High = 0, Max_Low = 0;

int TF2;  //  il Timeframe+1,  var. globale --> decisa in INIT ed usata nel ciclo di TF+1
double CCI_TF2_now;
double CCI_TF2_prev;

// variabili globali utilizzate nel ciclo di TF pi alto qui e nelle funzioni "Rect"
bool New_Rect = FALSE;	bool New_Rect_neg = FALSE;
datetime Start_Rect_Time;   
datetime Start_Rect_Time_neg;
datetime End_Rect_Time;    
datetime End_Rect_Time_neg;


//---- buffers
double HistoGray[];     // Variabili globali
double HistoBlue[];     // usate per i buffer dei diversi tipi di Histo
double HistoOrange[];
double HistoRed[];
double HistoBlack[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   // Indicator Name showed
   
   
   // HAH
   // if ( TimeCurrent() > StrToTime("2011.2.24 00:00:00") && TimeCurrent() < StrToTime("2010.12.31 00:00:00") ) 
      // {
      // Alert("Contact");
      // Alert(Indi_Name+" Indicator is expiring in a week.");
      // }
   
   // if (TimeCurrent() > StrToTime("2011.2.31 00:00:00")) 
      // {
      // Alert("Contact");
      // Alert(Indi_Name+");
      // expired = false;
      // return (0);
      // }
      
//---- CCI Histo Colours
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,HistoGray);
   
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,HistoBlue);
   
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,HistoOrange);
   
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,HistoRed);
   
   SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(4,HistoBlack);

    timeFrame         = stringToTimeFrame(TimeFrame);
    indicatorFileName = WindowExpertName();
    returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
    Indi_Name         = "Momentum Scalper";
    IndicatorShortName(Indi_Name);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                    
//+------------------------------------------------------------------+
int deinit()
  {
  /*  // non mi funziona, alcuni Rettangoli non vengono cancellati
  int a=0;
  while ( a < ObjectsTotal(OBJ_RECTANGLE) ) 
        {
        string name = ObjectName(a);
        if ( StringFind(name, Indi_Name, 0) != -1 ) ObjectDelete(name);
        a++;
        } 
  */   
  deleteObjects();  
  return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                            
//+------------------------------------------------------------------+
void deleteObjects(string add="")
{
   string lookFor       = Indi_Name+add;
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if (StringSubstr(name,0,lookForLength)==lookFor) ObjectDelete(name);
   }
}

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { HistoGray[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);  
                  HistoGray[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Momentum_Period,num_bars,momentum,"",OverSold_OverBought,"","",Show_Different_Background,Positive_Background_Color,Negative_Background_Color,"","",Always_Show_Price_Divergence,"",Main_Window_Background,0,y);       
                  HistoBlue[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Momentum_Period,num_bars,momentum,"",OverSold_OverBought,"","",Show_Different_Background,Positive_Background_Color,Negative_Background_Color,"","",Always_Show_Price_Divergence,"",Main_Window_Background,1,y); 
                  HistoOrange[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Momentum_Period,num_bars,momentum,"",OverSold_OverBought,"","",Show_Different_Background,Positive_Background_Color,Negative_Background_Color,"","",Always_Show_Price_Divergence,"",Main_Window_Background,2,y); 
                  HistoRed[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Momentum_Period,num_bars,momentum,"",OverSold_OverBought,"","",Show_Different_Background,Positive_Background_Color,Negative_Background_Color,"","",Always_Show_Price_Divergence,"",Main_Window_Background,3,y);
                  HistoBlack[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Momentum_Period,num_bars,momentum,"",OverSold_OverBought,"","",Show_Different_Background,Positive_Background_Color,Negative_Background_Color,"","",Always_Show_Price_Divergence,"",Main_Window_Background,4,y);                                              
            } 
         return(0);
         }
   
   // if (expired) return (0); 
    
   // CHECK
   counted_bars=IndicatorCounted();

   cs = Momentum_Period + num_bars; //checksum used to see if parameters have been changed

   if ((cs==prevcs) && 								// && (commodt == Symbol()) erased 
      (frame == (Time[4] - Time[5])) &&
      ((Bars - prevbars) < 2))
      startpar = Bars - prevbars; 
   else 
      startpar = -1;  //params haven't changed only need to calculate new bar

   //commodt = Symbol();
   frame = Time[4] - Time[5];
   prevbars = Bars;
   prevcs = cs;

   if (startpar == 1 || startpar == 0)  
      bar = startpar;
   else 
      initDo = true;   
   // END CHECK: if check OK, BAR = 0, cycle "FOR" only of the last bar


   // In case of first tick or checksum error
   // initialize buffers and do all the "NumBars" in "FOR" cycle 
   if (initDo) 
      {
      HistoGray[num_bars-1]=0;
      HistoBlue[num_bars-1]=0;
      HistoOrange[num_bars-1]=0;
      HistoRed[num_bars-1]=0;
      bar=num_bars-2;
      initDo=false;
      
      int window=WindowFind(Indi_Name);           // cancelliamo i vecchi Rettangoli 
      ObjectsDeleteAll(window,OBJ_RECTANGLE);     // (es. se cambiamo TF)
      
      ObjectsDeleteAll(0,OBJ_RECTANGLE);           // cancelliamo i vecchi Rettangoli nella Chart Window
      }
       
          
   // Core Function Start (FOR)
   for (i = bar; i >= 0; i--) 
   {   
      // all the buffers to zero to avoid
      // overlap of histos (last histo erased)
      HistoGray[i] = EMPTY_VALUE;
      HistoBlue[i] = EMPTY_VALUE;
      HistoOrange[i] = EMPTY_VALUE;
      HistoRed[i] = EMPTY_VALUE;
      HistoBlack[i] = EMPTY_VALUE;
      
      bool change_of_sign = FALSE;
      
      now = iCCI(NULL,0,Momentum_Period,PRICE_TYPICAL,i);
      prev = iCCI(NULL,0,Momentum_Period,PRICE_TYPICAL,i+1);
      now_high = iHigh(NULL,0,i);
      prev_high = iHigh(NULL,0,i+1);
      now_low = iLow(NULL,0,i);
      prev_low = iLow(NULL,0,i+1);
      
      // change of sign => Max_CCI and Max_Price to zero (first CCI Red)
      if ((prev >= 0 && now < 0) || (prev <= 0 && now > 0)) 
          {Max_CCI = 0; change_of_sign = TRUE;
          Max_High = 0; Max_Low = 123456789;} 
      
      // Update Max at end of bar -- ogni confronto
      // viene effettuato sulla barra precedente 
      if ( MathAbs(prev)>MathAbs(Max_CCI) ) Max_CCI = prev; 
      if (now >=0) {if (prev_high > Max_High) Max_High = prev_high;}
      if (now <=0) {if (prev_low < Max_Low) Max_Low = prev_low;}
               
      // Colour it!      
      if (now >= momentum)
         {
         if ( now>prev && now>=Max_CCI ) HistoRed[i] = now;  //now>prev -- utile?
         if ( now<Max_CCI && now_high>=Max_High ) HistoBlue[i] = now; // **Divergence !!**
         if ( now_high<Max_High ) HistoOrange[i] = now;
         if (change_of_sign) HistoBlack[i] = momentum;  // HisoBlack (histo pi corto)
         }                                              // ridisegnato sopra ad Histo colorato

      if (now <= -momentum)
         {
         if ( now<prev && now<=Max_CCI ) HistoRed[i] = now;
         if ( now>Max_CCI && now_low<=Max_Low ) HistoBlue[i] = now; // **Divergence !!**
         if ( now_low>Max_Low ) HistoOrange[i] = now;
         if (change_of_sign) HistoBlack[i] = -momentum;
         }
      
      if (now > -momentum && now < momentum) 
         {
         if (change_of_sign) HistoBlack[i] = now; 
            else 
               {
               HistoGray[i] = now;
               if (Always_Show_Price_Divergence)
                  {
                  if ( now>0 && now<Max_CCI && now_high>=Max_High ) HistoBlue[i] = now; // **Divergence !!**
                  if ( now<0 && now>Max_CCI && now_low<=Max_Low ) HistoBlue[i] = now; // **Divergence !!**
                  }
               }
         }
      
   
   //**************** ciclo su Timeframe pi alto per colorare lo sfondo
   //**************** sfondo normalmente di un colore (grigio per me)
   //**************** viene colorato con il colore "Positive_Background Color"
   //**************** quando il TF pi alto  positivo
   //**************** mentre  colorato con il colore "Negative_Background Color"
   //**************** quando il TF pi alto  negativo
   
   if (Show_Different_Background)
      {
      
      int TF = Period (); //su quale TF stiamo?
      
      // mi sposto su TF+1
      int TimeFrame_Array[] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200};
      int a=0;
      while (a<=8)
            { 
            if (TF==TimeFrame_Array[a]) TF2=TimeFrame_Array[a+1];  
            a++;
            }
            
      // mi sposto su TF+1   
      
      int shift = TF2*60; // shift in secondi per End_Rect
      int shift_actual = TF*60;  // La funzione iTime non restituisce TIME di barra non esistenti: i-1 quando i=0
   
      CCI_TF2_now = iCCI(NULL,TF2,Momentum_Period,PRICE_TYPICAL,i);
      CCI_TF2_prev = iCCI(NULL,TF2,Momentum_Period,PRICE_TYPICAL,i+1);
      
      
	  //  ***** Higher TF > 0 ?? *****
      if (i!=0)  // lavoriamo su historical bar
         {                                    
         if (CCI_TF2_now>0 && CCI_TF2_prev<=0)  //CCI TF2 diventa positivo
             { New_Rect=TRUE; Start_Rect_Time=iTime(NULL,TF2,i); End_Rect_Time=iTime(NULL,TF2,i)+shift; Draw_Rect();} 
                                // Rettangolo che termina una barra pi avanti 
                                // cos  visibile anche alla prima barra
         if (New_Rect && CCI_TF2_now>0) { End_Rect_Time= iTime(NULL,TF2,i)+shift; Move_Rect(); }
         if (CCI_TF2_now<=0) New_Rect = FALSE; 
         }
       
         else {      // i=0 lavoriamo su barra attuale: muoviamo Rect su TF attuale
              if (New_Rect && CCI_TF2_now>0) { End_Rect_Time=iTime(NULL,TF,i)+shift_actual; Move_Rect(); } //CCI TF2 gi positivo
              if (!New_Rect && CCI_TF2_now>0 && CCI_TF2_prev<=0)  //CCI TF2 diventa positivo
                  { New_Rect = TRUE; Start_Rect_Time=iTime(NULL,TF,i); End_Rect_Time=iTime(NULL,TF,i)+shift_actual; Draw_Rect();} 
              if (CCI_TF2_now<=0) New_Rect = FALSE;
              }
     

	  //  ***** Higher TF < 0 ?? *****
      if (i!=0)  // lavoriamo su historical bar
         {                                    
         if (CCI_TF2_now<0 && CCI_TF2_prev>=0)  //CCI TF2 diventa negativo
             { New_Rect_neg=TRUE; Start_Rect_Time_neg=iTime(NULL,TF2,i); End_Rect_Time_neg=iTime(NULL,TF2,i)+shift; Draw_Rect_neg();} 
                                // Rettangolo che termina una barra pi avanti 
                                // cos  visibile anche alla prima barra
         if (New_Rect_neg && CCI_TF2_now<0) { End_Rect_Time_neg= iTime(NULL,TF2,i)+shift; Move_Rect_neg(); }
         if (CCI_TF2_now>=0) New_Rect_neg = FALSE; 
         }
       
         else {      // i=0 lavoriamo su barra attuale: muoviamo Rect su TF attuale
              if (New_Rect_neg && CCI_TF2_now<0) { End_Rect_Time_neg=iTime(NULL,TF,i)+shift_actual; Move_Rect_neg(); } //CCI TF2 gi negativo
              if (!New_Rect_neg && CCI_TF2_now<0 && CCI_TF2_prev>=0)  //CCI TF2 diventa negativo
                  { New_Rect_neg = TRUE; Start_Rect_Time_neg=iTime(NULL,TF,i); End_Rect_Time_neg=iTime(NULL,TF,i)+shift_actual; Draw_Rect_neg();} 
              if (CCI_TF2_now>=0) New_Rect_neg = FALSE;
              }
			  
      } //END IF Show_Different_Background

   
   } // END FOR
   return(0);
  }  // END START
  
  
  
//********* FUNZIONI **************

void Draw_Rect()
     {
     string Start_Rect_String = TimeToStr (Start_Rect_Time); 
     string name = Indi_Name+" "+Start_Rect_String;
     int window=WindowFind(Indi_Name); 
     ObjectCreate(name, OBJ_RECTANGLE, window, Start_Rect_Time, 1000, End_Rect_Time, -1000);
     ObjectSet(name, OBJPROP_COLOR, Positive_Background_Color);
     ObjectSet(name, OBJPROP_BACK, TRUE);
     
     if (Main_Window_Background)  // Draw the same Rect on Main Window (Chart Window)
         {
         name = Indi_Name+" Main "+Start_Rect_String;
         ObjectCreate(name, OBJ_RECTANGLE, 0, Start_Rect_Time, 1000, End_Rect_Time, -1000);
         ObjectSet(name, OBJPROP_COLOR, Positive_Background_Color);
         ObjectSet(name, OBJPROP_BACK, TRUE);
         }
     }

void Draw_Rect_neg()
     {
     string Start_Rect_String = TimeToStr (Start_Rect_Time_neg); 
     string name = Indi_Name+" "+Start_Rect_String;
     int window=WindowFind(Indi_Name); 
     ObjectCreate(name, OBJ_RECTANGLE, window, Start_Rect_Time_neg, 1000, End_Rect_Time_neg, -1000);
     ObjectSet(name, OBJPROP_COLOR, Negative_Background_Color);
     ObjectSet(name, OBJPROP_BACK, TRUE);
     
     if (Main_Window_Background)  // Draw the same Rect on Main Window (Chart Window)
         {
         name = Indi_Name+" Main "+Start_Rect_String;
         ObjectCreate(name, OBJ_RECTANGLE, 0, Start_Rect_Time_neg, 1000, End_Rect_Time_neg, -1000);
         ObjectSet(name, OBJPROP_COLOR, Negative_Background_Color);
         ObjectSet(name, OBJPROP_BACK, TRUE);
         }
     }
     
void Move_Rect()
     {
     string Start_Rect_String = TimeToStr (Start_Rect_Time); 
     string name = Indi_Name+" "+Start_Rect_String;
     ObjectMove(name, 1, End_Rect_Time, -1000);  // Sposto la coordinata 2 dell'oggetto 
     
     if (Main_Window_Background)  
         {
         name = Indi_Name+" Main "+Start_Rect_String;
         ObjectMove(name, 1, End_Rect_Time, -1000);
         }
     }

void Move_Rect_neg()
     {
     string Start_Rect_String = TimeToStr (Start_Rect_Time_neg); 
     string name = Indi_Name+" "+Start_Rect_String;
     ObjectMove(name, 1, End_Rect_Time_neg, -1000);  // Sposto la coordinata 2 dell'oggetto 
     
     if (Main_Window_Background)  
         {
         name = Indi_Name+" Main "+Start_Rect_String;
         ObjectMove(name, 1, End_Rect_Time_neg, -1000);
         }
     }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   ts = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(ts, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     ts = StringSetChar(ts, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     ts = StringSetChar(ts, length, tchar + 224);
   }
   return(ts);
}
